
(*-------------------------------------------------------------------------*)
(* file             : mouse.mod                                            *)
(* description      : implementation of the mouse module                   *)
(* language         : GPM Modula-2                                         *)
(* organization     : -                                                    *)
(* autor            : Julian Miglio                                        *)
(* issue date       : June 14 2003                                         *)
(* version.release  : 1.1                                                  *)
(* notes            :                                                      *)
(*-------------------------------------------------------------------------*)


IMPLEMENTATION MODULE Mouse;

FROM Types IMPORT Card8, Card16;
FROM Low   IMPORT Dpmi_Regs, __dpmi_int;


   PROCEDURE Show_Mouse;
   VAR

      Regs : Dpmi_Regs;

   BEGIN

      Regs.Ax := 0001H;

      __dpmi_int( 33H, Regs );

   END Show_Mouse;


   PROCEDURE Hide_Mouse;
   VAR

      Regs : Dpmi_Regs;

   BEGIN

      Regs.Ax := 0002H;

      __dpmi_int( 33H, Regs );

   END Hide_Mouse;

   PROCEDURE Get_Mouse( 
                VAR X       : Card16;
                VAR Y       : Card16;
                VAR Buttons : Card8 );
   VAR

      Regs  : Dpmi_Regs;

   BEGIN

      Regs.Ax := 0003H;

      __dpmi_int( 33H, Regs );

      X       := Regs.Cx;
      Y       := Regs.Dx;
      Buttons := Regs.Bx;

   END Get_Mouse;

END Mouse.

