
(*-------------------------------------------------------------------------*)
(* file             : test.mod                                             *)
(* description      : This is a test program for the mouse module,         *)
(*                    it prints the mouse position by pressing of the left *)
(*                    button and exits by pressing of the right button.    *)
(* language         : GPM Modula-2                                         *)
(* organization     : -                                                    *)
(* autor            : Julian Miglio                                        *)
(* issue date       : June 14 2003                                         *)
(* version.release  : 1.1                                                  *)
(* notes            : To detect a mouse button event it is necessary to    *)
(*                    save the data in a park variable and check for the   *)
(*                    change every time we get the new information.        *)
(*                    Common events are the pressing of a button but we    *)
(*                    can detect the corresponding release.                *)
(*                    The value of the X and Y coordinates shall be        *)
(*                    adapted to the current graphic mode.                 *)
(*                    The mouse module requires the corrrect mouse device  *)
(*                    to be installed before use.                          *)
(*-------------------------------------------------------------------------*)

MODULE TEST;

FROM Types    IMPORT Card8, Card16;
FROM Mouse    IMPORT Show_Mouse, Hide_Mouse, Get_Mouse;
FROM InOut    IMPORT WriteLn, WriteCard, WriteString;

VAR

   X           : Card16;  (* that is the x-coordinate *)
   Y           : Card16;  (* that is the y-coordinate *)
   Buttons     : Card8;   (* that is the button information *)
   Old_Buttons : Card8;   (* that is the saved button information *)

BEGIN

   Old_Buttons := 0;

   WriteString( "This is a test for the Mouse Module." );
   WriteLn;
   WriteString( "the left button prints the mouse coordinates," );
   WriteLn;
   WriteString( "the right button exits from the program." );
   WriteLn;

   Show_Mouse;

   LOOP

      Get_Mouse( X, Y, Buttons );

      IF Buttons <> Old_Buttons THEN

         IF Buttons = 1 THEN
            Hide_Mouse;
            WriteString( "X = " );
            WriteCard( X, 5 );
            WriteString( "   Y = " );
            WriteCard( Y, 5 );
            WriteLn;
            Show_Mouse;
         END;

         IF Buttons = 2 THEN
            EXIT;
         END;
      END;

      Old_Buttons := Buttons;

   END;

   Hide_Mouse;

END TEST.



